package eaadapter.common.util;

public interface ModelConstants {
	
	/* EASTADL*/
	public static final String DEFAULT_NSURI = "http://east-adl.info";
    public static final String DEFAULT_NSPREFIX = "EA";
    public static final String DEFAULT_EASTADL_FILE_EXTENSION = "eaxml";
    public static final String EASTADL_GENMODEL_PROPERTIES = "/resources/genmodel_eastadl.properties";
    
    /* SAFE */
    public static final String DEFAULT_SAFE_NSURI = "http://safe-project.eu";
    public static final String DEFAULT_SAFE_FILE_EXTENSION = "safe";
    public static final String SAFE_GENMODEL_PROPERTIES = "/resources/genmodel_safe.properties";
    
    /* GEASTADL */
    public static final String GEASTADL_ROOT_PCK_NAME = "geastadl";
    public static final String GEASTADL_GENMODEL = "geastadl.genmodel";
    
    /* EASTADL21 */
    public static final String EASTADL_STUB_GENMODEL = "eastadlStub.genmodel";
    
    /* AUTOSAR41 */
    public static final String AUTOSAR_STUB_GENMODEL = "autosarStub.genmodel";
	
	/* Boolean String values*/
	public static final String TRUE_STRING = "true";
	public static final String FALSE_STRING = "false";
	
	/* Annotations types */
	public static final String ANNOTATION_STEREOTYPE = "Stereotype";
    public static final String ANNOTATION_TAGGED_VALUES = "TaggedValues";
    public static final String ANNOTATION_EAADAPTER = "EAAdapter";
	
	/* Stereotypes */
    public static final String STEREOTYPE_INSTANCE_REF = "instanceRef";
    public static final String STEREOTYPE_INSTANCE_REF_TARGET = "instanceRef.target";
    public static final String STEREOTYPE_INSTANCE_REF_CONTEXT = "instanceRef.context";
    public static final String STEREOTYPE_IS_OF_TYPE = "isOfType";
    public static final String STEREOTYPE_ATPMIXED = "atpMixed";
    public static final String STEREOTYPE_ATPMIXEDSTRING = "atpMixedString";
    public static final String STEREOTYPE_ATPABSTRACT = "atpAbstract";
    public static final String STEREOTYPE_ATPDERIVED = "atpDerived";
    public static final String STEREOTYPE_PRIMITIVE = "primitive";
    
    /* Tagged Value keys */
    public static final String TAGGED_VALUE_XML_NAME = "xml.name";
    public static final String TAGGED_VALUE_XML_NAME_PLURAL = "xml.namePlural";
    public static final String TAGGED_VALUE_XML_ROLE_ELEMENT = "xml.roleElement";
    public static final String TAGGED_VALUE_XML_ROLE_WRAPPER_ELEMENT = "xml.roleWrapperElement";
    public static final String TAGGED_VALUE_XML_TYPE_ELEMENT = "xml.typeElement";
    public static final String TAGGED_VALUE_XML_TYPE_WRAPPER_ELEMENT = "xml.typeWrapperElement";
    public static final String TAGGED_VALUE_XML_NS_PREFIX = "xml.nsPrefix";
    public static final String TAGGED_VALUE_XML_NS_URI  = "xml.nsUri";
    public static final String TAGGED_VALUE_XML_ATTRIBUTE = "xml.attribute";
    public static final String TAGGED_VALUE_EXTENSION_POINT = "xml.extensionPoint";
    public static final String TAGGED_VALUE_XML_XSD_LENGTH = "xml.xsd.length";
    public static final String TAGGED_VALUE_XML_XSD_MAX_EXCLUSIVE = "xml.xsd.maxExclusive";
    public static final String TAGGED_VALUE_XML_XSD_MAX_INCLUSIVE = "xml.xsd.maxInclusive";
    public static final String TAGGED_VALUE_XML_XSD_MAX_LENGTH = "xml.xsd.maxLength";
    public static final String TAGGED_VALUE_XML_XSD_MIN_EXCLUSIVE = "xml.xsd.minExclusive";
    public static final String TAGGED_VALUE_XML_XSD_MIN_INCLUSIVE = "xml.xsd.minInclusive";
    public static final String TAGGED_VALUE_XML_XSD_MIN_LENGTH = "xml.xsd.minLength";
    public static final String TAGGED_VALUE_XML_ENFORCE_MIN_MULTIPLICITY = "xml.enforceMinMultiplicity";
    public static final String TAGGED_VALUE_XML_ENFORCE_MAX_MULTIPLICITY = "xml.enforceMaxMultiplicity";
    public static final String TAGGED_VALUE_XML_XSD_PATTERN = "xml.xsd.pattern";
    public static final String TAGGED_VALUE_XML_XSD_TARGET = "xml.xsd.namespace";
    public static final String TAGGED_VALUE_XML_XSD_TOTAL_DIGITS = "xml.xsd.totalDigits";
    public static final String TAGGED_VALUE_XML_XSD_WHITESPACE = "xml.xsd.whiteSpace";
    public static final String TAGGED_VALUE_XML_XSD_CUSTOM_TYPE = "xml.xsd.customType";
    public static final String TAGGED_VALUE_XML_XSD_TYPE = "xml.xsd.type";
    public static final String TAGGED_VALUE_XML_XSD_FRACTION_DIGITS = "xml.xsd.fractionDigits";
    public static final String TAGGED_VALUE_XML_TAGS = "xml.tags";
    public static final String TAGGED_VALUE_XML_GLOBAL_ELEMENT = "xml.globalElement";    
    public static final String EAADAPTER_METAMODEL_TYPE = "metaModelType";
    
    /* metamodel type */
    public static final String METAMODEL_TYPE_SAFE = "SAFE";
    public static final String METAMODEL_TYPE_EASTADL = "EAST-ADL";
    
    /* Configure properties*/
    public static final String MODEL_CONFIG_PROPERTIES_NAME = "config.properties";
    
    /* Properties */
    public static final String FILE_EXTENSIONS = "fileExtensions";
    public static final String COMPLIANCE_LEVEL = "complianceLevel";
    public static final String NON_NLS_MARKERS = "nonNLSMarkers";
    public static final String RUNTIME_VERSION = "runtimeVersion";
    public static final String MODEL_PLUGIN_CLASS = "modelPluginClass";
    public static final String MODEL_PLUGIN_VARIABLES = "modelPluginVariables";
    public static final String EDIT_PLUGIN_CLASS = "editPluginClass";
    public static final String EDIT_PLUGIN_VARIABLES = "editPluginVariables";
    public static final String CREATION_ICONS = "creationIcons";
    public static final String PROVIDER_ROOT_EXTENDS_CLASS = "providerRootExtendsClass";
    public static final String ROOT_EXTENDS_CLASS = "rootExtendsClass";
    public static final String ROOT_PACKAGE_CONTENT_TYPE_ID = "rootPackageContentTypeId";
    
    public static final String PROVIDER_PACKAGE_SUFFIX = "providers";
    
    public static final String SRC_GEN_DIRECTORY = "/src-gen";
    public static final String SRC_DIRECTORY = "/src";
    
    /* Suffix*/
    public static final String SUFFIX_NAME = "-IREF";
    public static final String SUFFIX_NAME_PLURAL = "-IREFS";
    public static final String SUFFIX_SINGULAR_TYPE_REF = "-TREF";
    public static final String SUFFIX_PLURAL_TYPE_REF = "-TREFS";
    public static final String SUFFIX_SINGULAR_REF = "-REF";
    public static final String SUFFIX_PLURAL_REF = "-REFS";
    
    /* Package name that contains the primitive data types*/
    public static final String DATA_TYPES = "DataTypes";
    public static final String PRIMITIVE_TYPES = "PrimitiveTypes";
    
    /* Boolean */
    public static final String BOOLEAN_TRUE = "true";
    public static final String BOOLEAN_FALSE = "false";
    
    /* JETEmitterDescriptor */
    public static final String TRAVERSAL_HELPER_JAVAJET = "model/TraversalHelper.javajet";
    public static final String TRAVERSAL_HELPER_CLASS = "org.eclipse.emf.codegen.ecore.templates.model.TraversalHelper";
    public static final String RELEASE_DESCRIPTOR_JAVAJET = "model/ReleaseDescriptor.javajet";
    public static final String RELEASE_DESCRIPTOR_CLASS = "org.eclipse.emf.codegen.ecore.templates.model.ReleaseDescriptor";
    public static final String ITEM_LABEL_PROVIDER_ADAPTER_FACTORY_JAVAJET = "edit/ItemLabelProviderAdapterFactory.javajet";
    public static final String ITEM_LABEL_PROVIDER_ADAPTER_FACTORY_CLASS = "org.eclipse.emf.codegen.ecore.templates.edit.ItemLabelProviderAdapterFactory";
    public static final String RELEASE_DESCRIPTOR_ITEM_LABEL_PROVIDER_JAVAJET = "edit/ReleaseDescriptorItemLabelProvider.javajet";
    public static final String RELEASE_DESCRIPTOR_ITEM_LABEL_PROVIDER_CLASS = "org.eclipse.emf.codegen.ecore.templates.edit.ReleaseDescriptorItemLabelProvider";
    public static final String FACTORY_CLASS_JAVAJET = "model/FactoryClass.javajet";
    public static final String FACTORY_CLASS = "org.eclipse.emf.codegen.ecore.templates.model.Factory";
    public static final String PACKAGE_CLASS_JAVAJET = "model/PackageClass.javajet";
    public static final String PACKAGE_CLASS = "org.eclipse.emf.codegen.ecore.templates.model.Package";
    public static final String SWITCH_CLASS_JAVAJET = "model/SwitchClass.javajet";
    public static final String SWITCH_CLASS = "org.eclipse.emf.codegen.ecore.templates.model.Switch";
    
    /* Copy right*/
    public static final String COPY_RIGHT = "<copyright>\r\nCopyright (c) Continental AG and others.\r\nAll rights reserved. This program and the accompanying materials are made navailable under the terms of the Eclipse Public License \r\nwhich accompanies this distribution, and is navailable at http://www.eclipse.org/org/documents/epl-v10.php\r\n\r\nContributors:\r\n\tContinental AG, 2012 Matthias Nick - Initial API and implementation\r\n</copyright>";
    
    /* UI */
    public static final String _UI_FILECONFLICT_LABEL = "_UI_FileConflict_label";
    public static final String _WARN_FILECONFLICT = "_WARN_FileConflict";
    public static final String _UI_CREATEMODELERROR_MESSAGE = "_UI_CreateModelError_message";
    public static final String _UI_SELECTIONPAGE_LABEL = "_UI_SelectionPage_label";
    public static final String _UI_OBJECTCOLUMN_LABEL = "_UI_ObjectColumn_label";
    public static final String _UI_SAFECOLUMN_LABEL = "_UI_SelfColumn_label";
    public static final String _UI_NOOBJECTSELECTED = "_UI_NoObjectSelected";
    public static final String _UI_SINGLEOBJECTSELECTED = "_UI_SingleObjectSelected";
    public static final String _UI_MULTIOBJECTSELECTED = "_UI_MultiObjectSelected";
    
    /* */
    public static final String MENU_MANAGER_TEXT = "#PopUp";
    public static final String SEPARATOR_GROUP_NAME = "additions";
    
    /* */
    public static final String eaModelLabel_Text = "Enterprise Architect Model File:";
    public static final String eaFileLabel_Text = "Enterprise Architect Project File:";
    public static final String metaModelTypeLabel_Text = "Type of meta-model:";
    public static final String loadButton_Text = "Load complete model...";
    public static final String loadButton_Job_Name = "Reading EA File";
    public static final String initialize_RootPckNameField_UIJob_Name = "Initialize RootPckNameField";
    public static final String rootPckNameLabel_Text = "Root Package Name:";
    public static final String versionLabel_Text = "Release Version:";
    public static final String geastadlRootDirLabel_Text = "GEASTADL Root Directory:";
    public static final String geastadlRootDirButton_Text = " ... ";
    public static final String exportEcoreButton_Text = "Create Ecore";
    public static final String createEcore_Job_Name = "Creating Ecore";
    public static final String createModelEcoreAndCodeButton_Text1 = "Create ";
    public static final String createModelEcoreAndCodeButton_Text2 = " meta-model implementation";
    public static final String createMMImplementation_Job_Name = "Creating meta-model implementation";
    public static final String eaControlPage_Text = "Enterprise Architect Control";
    
    /* */
    public static final String error_Message = "An error occured.\nReason: ";
    public static final String success_Message = "Model loaded successfully.\nLoad took ";
    public static final String error_RootPackageMustSpecified = "Root package name must be specified!";
    public static final String error_GeneratedEcoreContainsErrors = "Generated the Ecore.\nAttention, the generated Ecore contains errors, please validate it to see the errors";
    public static final String success_EcoreCreated = "Ecore created successfully";
    public static final String output_EcoreCreationTook = "ecore creation took: ";
    public static final String error_ReleaseVersionMustSpecified = " release version must be specified!";
    public static final String error_GEASTADLRootDirectoryMustSpecified = "GEASTADL root directory must be specified!";
    public static final String success_MMCreated = " meta-model implementation created successfully";
    public static final String output_MMCreationTook = " meta-model implementation creation took: ";
    public static final String exception_LoadModel = "Please load the model first!";
    
    public static final String error_EASTADLStubDirectoryMustSpecified = "EAST-ADL stub directory must be specified!";
    public static final String error_AUTOSARStubDirectoryMustSpecified = "AUTOSAR stub directory must be specified!";
    
}
