package eaadapter.ea2ecore.postprocessings;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;

import org.eclipse.core.resources.IContainer;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;

import eaadapter.ea2ecore.PostProcessingTemplate;
import eaadapter.ea2ecore.postprocessings.util.Utils;

public class CopyAutosarFiles extends PostProcessingTemplate {
	
	private static final String AUTOSAR_STUB_GENMODEL = "autosarStub.genmodel";
	private static final String AUTOSAR_STUB_ECORE = "autosarStub.ecore";
	
//	private static final String GAUTOSAR_GENMODEL = "gautosar.genmodel";
//	private static final String GAUTOSAR_ECORE = "gautosar.ecore";
	
	private File ecoreModelFile = null;
	private String autosarStubRootDir = null;
	
	public CopyAutosarFiles(File ecoreModelFile, String autosarStubRootDir) {
		this.ecoreModelFile = ecoreModelFile;
		this.autosarStubRootDir = autosarStubRootDir;
	}
	
	private void copyFile (File file, IContainer destFolder) throws FileNotFoundException, CoreException {
		IFile newFile = destFolder.getFile(new Path(file.getName()));
		newFile.create(new FileInputStream(file), true, null);
	}

	@Override
	public void execute() {
		IPath genModelPath = new Path(ecoreModelFile.getAbsolutePath());
		IFile iFile = ResourcesPlugin.getWorkspace().getRoot().getFileForLocation(
				genModelPath);
		IContainer destFolder = iFile.getParent();
		
		try {
//			//copy GAUTOSAR ecore
//			File file = Utils.findFileByName(new File(autosarStubRootDir), 
//					GAUTOSAR_ECORE);
//			copyFile(file, destFolder);
//			//copy GAUTOSAR genmodel
//			file = Utils.findFileByName(new File(autosarStubRootDir), 
//					GAUTOSAR_GENMODEL);
//			copyFile(file, destFolder);
			
			//copy AUTOSAR STUB ecore
			File file = Utils.findFileByName(new File(autosarStubRootDir), 
					AUTOSAR_STUB_ECORE);
			copyFile(file, destFolder);
			
			//copy AUTOSAR STUB genmodel
			file = Utils.findFileByName(new File(autosarStubRootDir), 
					AUTOSAR_STUB_GENMODEL);
			copyFile(file, destFolder);
		} catch (FileNotFoundException e) {
			getLogger().error(e.getMessage());
			e.printStackTrace();
		} catch (CoreException e) {
			getLogger().error(e.getMessage());
			e.printStackTrace();
		}
	}
}

