package eaadapter.ea2ecore.postprocessings;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;

import org.eclipse.core.resources.IContainer;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;

import eaadapter.ea2ecore.PostProcessingTemplate;
import eaadapter.ea2ecore.postprocessings.util.Utils;

public class CopyEastadlFiles extends PostProcessingTemplate {
	
	private static final String EASTADL_STUB_GENMODEL = "eastadlStub.genmodel";
	private static final String EASTADL_STUB_ECORE = "eastadlStub.ecore";
	
//	private static final String GEASTADL_GENMODEL = "geastadl.genmodel";
//	private static final String GEASTADL_ECORE = "geastadl.ecore";
	
	private File ecoreModelFile = null;
	private String eastadlStubRootDir = null;
	
	public CopyEastadlFiles(File ecoreModelFile, String eastadlStubRootDir) {
		this.ecoreModelFile = ecoreModelFile;
		this.eastadlStubRootDir = eastadlStubRootDir;
	}
	
	private void copyFile (File file, IContainer destFolder) throws FileNotFoundException, CoreException {
		IFile newFile = destFolder.getFile(new Path(file.getName()));
		newFile.create(new FileInputStream(file), true, null);
	}

	@Override
	public void execute() {
		IPath genModelPath = new Path(ecoreModelFile.getAbsolutePath());
		IFile iFile = ResourcesPlugin.getWorkspace().getRoot().getFileForLocation(
				genModelPath);
		IContainer destFolder = iFile.getParent();
		
		try {
//			//copy GEASTADL ecore
//			File file = Utils.findFileByName(new File(eastadlStubRootDir), 
//					GEASTADL_ECORE);
//			copyFile(file, destFolder);
//			//copy GEASTADL genmodel
//			file = Utils.findFileByName(new File(eastadlStubRootDir), 
//					GEASTADL_GENMODEL);
//			copyFile(file, destFolder);
			
			//copy ecore
			File file = Utils.findFileByName(new File(eastadlStubRootDir), 
					EASTADL_STUB_ECORE);
			copyFile(file, destFolder);
			//copy genmodel
			file = Utils.findFileByName(new File(eastadlStubRootDir), 
					EASTADL_STUB_GENMODEL);
			copyFile(file, destFolder);
		} catch (FileNotFoundException e) {
			getLogger().error(e.getMessage());
			e.printStackTrace();
		} catch (CoreException e) {
			getLogger().error(e.getMessage());
			e.printStackTrace();
		}
	}
}
