/**
 * <copyright>
 * 
 * Copyright (c) Continental AG and others.
 * All rights reserved. This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 
 * which accompanies this distribution, and is
 * available at http://www.eclipse.org/org/documents/epl-v10.php
 * 
 * Contributors: 
 *     Continental AG - Initial API and implementation
 * 
 * </copyright>
 */
package eaadapter.ea2ecore.postprocessings;

import java.io.File;

import eaadapter.ea2ecore.PostProcessingTemplate;
import eaadapter.xsd.XSDGenerator;

public class GenerateXSD extends PostProcessingTemplate {
    
    private String outputDir = null;
    private String version = null;
    
    public GenerateXSD(String outputDir, String version) {
        this.outputDir = outputDir;
        this.version = version;
    }

    @Override
    public void execute() {
        
        File output = new File(outputDir + "/eastadl_" + version + ".xsd");
        new XSDGenerator(output, getModel(), version).run();
    }
}
