package eaadapter.templates.source;

import java.util.Properties;

public class SAFESourceRevision {
	public final int major;
	public final int minor;
	public final int revision;

	public SAFESourceRevision(Properties properties) {
		major = Integer.parseInt(properties.getProperty("version.major"));
		minor = Integer.parseInt(properties.getProperty("version.minor"));
		revision = Integer.parseInt(properties.getProperty("version.revision"));
	}

	private SAFESourceRevision() {
		major = 0;
		minor = 0;
		revision = 0;
	}

	public int getRevisionOrdinal() {
		return major * 100 + minor * 10 + revision;
	}

	public String getNamespacePostfix() {
		return major + "." + minor + "." + revision;
	}

	public String getEPackageNsURIPostfixPattern() {
		return major + "\\\\." + minor + "\\\\." + revision + "(/\\\\w+)+";
	}

	public String getReleaseLabel() {
		return "SAFE " + major + "." + minor + "." + revision;
	}
}