package eaadapter.xsd;

import java.io.File;
import java.io.IOException;
import java.net.URL;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

/**
 * The activator class controls the plug-in life cycle
 */
public class Activator extends AbstractUIPlugin {

	// The plug-in ID
	public static final String PLUGIN_ID = "eaadapter.xsd"; //$NON-NLS-1$

	// The shared instance
	private static Activator plugin;
	
	/**
	 * The constructor
	 */
	public Activator() {
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
		plugin = this;
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static Activator getDefault() {
		return plugin;
	}
	
    /**
     * Returns the URL of a resource if one for the given path exists. Otherwise
     * <code>null</code> is returned.
     * 
     * @param path of the resource in this bundel.
     *           
     * @return URL or the resource or <code>null</code>
     */
    public URL getResourceURL(String path) {
        URL url = getBundle().getResource(path);
        
        if (url != null) {
            try {
                return FileLocator.resolve(url);
            } catch (IOException ex) {
                //do nothing
            }
        }
        
        return null;
    }

    /**
     * Returns a file according to the given path if it exists. Otherwise 
     * <code>null</code> is returned.
     *
     * @param path of the file
     *          
     * @return File according to the given path or <code>null</code> if it not 
     * exists.
     */
    public File getFile(String path) {
        URL url = getResourceURL(path);
        
        if (url != null) {
            try {
                url = FileLocator.toFileURL(url);
                return new File(url.getPath());
            } catch (IOException ex) {
                //do notihing
            }
        }
        return null;
    }
}
