/**
 * <copyright>
 * 
 * Copyright (c) Continental AG and others.
 * All rights reserved. This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 
 * which accompanies this distribution, and is
 * available at http://www.eclipse.org/org/documents/epl-v10.php
 * 
 * Contributors: 
 *     Continental AG - Initial API and implementation
 * 
 * </copyright>
 */
package eaadapter.xsd.model;

/**
 * Specialisation of the type <code>ARXSDAnnotation</code>
 */
public class CustomAnnotation extends EAXSDAnnotation {

    /**
     * Returns <code>true</code> if there's some annotation value available.
     *
     * @return   <code>true</code> <=> There's some annotation value available.
     */
    public boolean isAvailable() {
        return (!getStereotype().isEmpty()) ||
            (!getTag().isEmpty()) ||
            (getDocumentation() != null);
    }

    /**
     * Returns <code>true</code> if there's some annotation value available.
     *
     * @return   <code>true</code> <=> There's some annotation value available.
     */
    public boolean isTagOrDocumentation() {
        return (! getTag().isEmpty()) ||
            (getDocumentation() != null);
    }
}

