/**
 * <copyright>
 * 
 * Copyright (c) Continental AG and others.
 * All rights reserved. This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 
 * which accompanies this distribution, and is
 * available at http://www.eclipse.org/org/documents/epl-v10.php
 * 
 * Contributors: 
 *     Continental AG - Initial API and implementation
 * 
 * </copyright>
 */
package eaadapter.xsd.model;

import javax.xml.bind.annotation.XmlRegistry;

/**
 * Specialisation of the type <code>ObjectFactory</code>
 */
@XmlRegistry
public class CustomObjectFactory extends ObjectFactory {
    
    /**
     * {@inheritDoc}
     */
    @Override
	public EAXSDSubtypes createEAXSDSubtypes() {
        return new CustomSubtypes();
    }

    /**
     * {@inheritDoc}
     */
    @Override
	public EAXSDAnnotation createEAXSDAnnotation() {
        return new CustomAnnotation();
    }
    
    /**
     * {@inheritDoc}
     */
    @Override
	public EAXSDClassType createEAXSDClassType() {
        return new CustomClassType();
    }
    
    /**
     * {@inheritDoc}
     */
    @Override
	public EAXSDAbstract createEAXSDAbstract() {
        return new CustomAbstract();
    }
}