/**
 * <copyright>
 * 
 * Copyright (c) Continental AG and others.
 * All rights reserved. This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 
 * which accompanies this distribution, and is
 * available at http://www.eclipse.org/org/documents/epl-v10.php
 * 
 * Contributors: 
 *     Continental AG - Initial API and implementation
 * 
 * </copyright>
 */
package eaadapter.xsd.model;

import java.util.ArrayList;
import java.util.List;

/**
 * Specialisation of the type <code>EAXSDSubtypes</code>
 */
public class CustomSubtypes extends EAXSDSubtypes {

    /**
     * Returns a list of concrete subtypes.
     * 
     * @return A list of concrete subtypes. Not <code>null</code>.
     */
    public List<EAXSDType> getConcreteSubtypes() {
        List<EAXSDType> result = new ArrayList<EAXSDType>(getSubtype());
        for (int i = result.size() - 1; i >= 0; i--) {
            if (!Boolean.TRUE.equals(result.get(i).isConcrete())) {
                result.remove(i);
            }
        }
        return result;
    }
} 