/**
 * <copyright>
 * 
 * Copyright (c) Continental AG and others.
 * All rights reserved. This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 
 * which accompanies this distribution, and is
 * available at http://www.eclipse.org/org/documents/epl-v10.php
 * 
 * Contributors: 
 *     Continental AG - Initial API and implementation
 * 
 * </copyright>
 */
package eaadapter.xsd.stringtemplates.adapters;

import java.text.SimpleDateFormat;
import java.util.Date;

import javax.xml.bind.annotation.adapters.XmlAdapter;

public class DateAdapter extends XmlAdapter<String, Date> {
    
    private static final SimpleDateFormat SDF = new SimpleDateFormat( "yyyy-MM-dd" );
    
    /**
     * {@inheritDoc}
     */
    @Override
    public Date unmarshal(String v) throws Exception {
        if (v == null) {
            return null;
        } else {
            return SDF.parse(v);
        }
    }
    
    /**
     * {@inheritDoc}
     */
    @Override
    public String marshal(Date v) throws Exception {
        if (v == null) {
            return null;
        } else {
            return SDF.format(v);
        }
    }
}
