package eaadapter.xsd.util;

import org.eclipse.emf.ecore.EModelElement;

import eaadapter.common.util.ModelUtil;

public class TaggedValueHelper {
    
    private EModelElement element = null;
    
    public TaggedValueHelper(EModelElement element) {
        this.element = element;
    }
    
    public Integer getIntegerValue(String tag) {
        return getIntegerValue(tag, null);
    }
    
    public Integer getIntegerValue(String tag, Integer defaultValue) {
        String value = ModelUtil.getTaggedValue(element, tag);
        
        if (value != null)  {
            return Integer.valueOf(value);
        } else {
            return defaultValue;
        }
    }
    
    public String getStringValue(String tag) {
        return getStringValue(tag, null);
    }
    
    public String getStringValue(String tag, String defaultValue) {
        String value = ModelUtil.getTaggedValue(element, tag);
        
        if (value == null || value.length() <= 0) {
            return defaultValue;
        }
        
        return value;
    }
    
    public Boolean getBooleanValue(String key) {
        return getBooleanValue(key, null);
    }

    public Boolean getBooleanValue(String tag, Boolean defaultValue) {
        String value = ModelUtil.getTaggedValue(element, tag);
        if (value == null) {
            return defaultValue;
        } else {
            return Boolean.valueOf(value);
        }
    }

}
