package eaadapter.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.util.EcoreUtil;

import eaadapter.EAElement;
import eaadapter.EARepository;
import eaadapter.abstracthierachy.EANamedElement;
import eaadapter.datatypes.MetaModelType;

public class EaadapterModelType {
	public static boolean isEASTADL(EANamedElement e) {
		if (typeOfMetaModel(e).equals(MetaModelType.EASTADL))
			return true;
		return false;
	}
	
	public static boolean isSAFE(EANamedElement e) {
		if (typeOfMetaModel(e).equals(MetaModelType.SAFE))
			return true;
		return false;		
	}
	
	public static boolean isSTANDARDUML(EANamedElement e) {
		if (typeOfMetaModel(e).equals(MetaModelType.STANDARDUML))
			return true;
		return false;		
	}
	
	public static boolean isEASTADLorSAFE(EANamedElement e) {
		if (isEASTADL(e) || isSAFE(e))
			return true;
		return false;
	}
	
	private static MetaModelType typeOfMetaModel(EANamedElement e) {
		EObject root = EcoreUtil.getRootContainer(e);
		if (root instanceof EARepository) {
			return ((EARepository) root).getTypeOfMetaModel();
		}
		return MetaModelType.STANDARDUML; //by default
	}
}
