/**
 */
package eastadl21.east_adl.structure.systemmodeling;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see eastadl21.east_adl.structure.systemmodeling.SystemmodelingFactory
 * @model kind="package"
 * @generated
 */
public interface SystemmodelingPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "systemmodeling";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://east-adl.info/2.1.10/eastadl21/east_adl/structure/systemmodeling";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	SystemmodelingPackage eINSTANCE = eastadl21.east_adl.structure.systemmodeling.impl.SystemmodelingPackageImpl.init();

	/**
	 * The meta object id for the '{@link eastadl21.east_adl.structure.systemmodeling.impl.SystemModelImpl <em>System Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see eastadl21.east_adl.structure.systemmodeling.impl.SystemModelImpl
	 * @see eastadl21.east_adl.structure.systemmodeling.impl.SystemmodelingPackageImpl#getSystemModel()
	 * @generated
	 */
	int SYSTEM_MODEL = 0;

	/**
	 * The number of structural features of the '<em>System Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_MODEL_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link eastadl21.east_adl.structure.systemmodeling.impl.AnalysisLevelImpl <em>Analysis Level</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see eastadl21.east_adl.structure.systemmodeling.impl.AnalysisLevelImpl
	 * @see eastadl21.east_adl.structure.systemmodeling.impl.SystemmodelingPackageImpl#getAnalysisLevel()
	 * @generated
	 */
	int ANALYSIS_LEVEL = 1;

	/**
	 * The number of structural features of the '<em>Analysis Level</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANALYSIS_LEVEL_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link eastadl21.east_adl.structure.systemmodeling.impl.DesignLevelImpl <em>Design Level</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see eastadl21.east_adl.structure.systemmodeling.impl.DesignLevelImpl
	 * @see eastadl21.east_adl.structure.systemmodeling.impl.SystemmodelingPackageImpl#getDesignLevel()
	 * @generated
	 */
	int DESIGN_LEVEL = 2;

	/**
	 * The number of structural features of the '<em>Design Level</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DESIGN_LEVEL_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link eastadl21.east_adl.structure.systemmodeling.impl.ImplementationLevelImpl <em>Implementation Level</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see eastadl21.east_adl.structure.systemmodeling.impl.ImplementationLevelImpl
	 * @see eastadl21.east_adl.structure.systemmodeling.impl.SystemmodelingPackageImpl#getImplementationLevel()
	 * @generated
	 */
	int IMPLEMENTATION_LEVEL = 3;

	/**
	 * The number of structural features of the '<em>Implementation Level</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPLEMENTATION_LEVEL_FEATURE_COUNT = 0;


	/**
	 * Returns the meta object for class '{@link eastadl21.east_adl.structure.systemmodeling.SystemModel <em>System Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>System Model</em>'.
	 * @see eastadl21.east_adl.structure.systemmodeling.SystemModel
	 * @generated
	 */
	EClass getSystemModel();

	/**
	 * Returns the meta object for class '{@link eastadl21.east_adl.structure.systemmodeling.AnalysisLevel <em>Analysis Level</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Analysis Level</em>'.
	 * @see eastadl21.east_adl.structure.systemmodeling.AnalysisLevel
	 * @generated
	 */
	EClass getAnalysisLevel();

	/**
	 * Returns the meta object for class '{@link eastadl21.east_adl.structure.systemmodeling.DesignLevel <em>Design Level</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Design Level</em>'.
	 * @see eastadl21.east_adl.structure.systemmodeling.DesignLevel
	 * @generated
	 */
	EClass getDesignLevel();

	/**
	 * Returns the meta object for class '{@link eastadl21.east_adl.structure.systemmodeling.ImplementationLevel <em>Implementation Level</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Implementation Level</em>'.
	 * @see eastadl21.east_adl.structure.systemmodeling.ImplementationLevel
	 * @generated
	 */
	EClass getImplementationLevel();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	SystemmodelingFactory getSystemmodelingFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link eastadl21.east_adl.structure.systemmodeling.impl.SystemModelImpl <em>System Model</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see eastadl21.east_adl.structure.systemmodeling.impl.SystemModelImpl
		 * @see eastadl21.east_adl.structure.systemmodeling.impl.SystemmodelingPackageImpl#getSystemModel()
		 * @generated
		 */
		EClass SYSTEM_MODEL = eINSTANCE.getSystemModel();

		/**
		 * The meta object literal for the '{@link eastadl21.east_adl.structure.systemmodeling.impl.AnalysisLevelImpl <em>Analysis Level</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see eastadl21.east_adl.structure.systemmodeling.impl.AnalysisLevelImpl
		 * @see eastadl21.east_adl.structure.systemmodeling.impl.SystemmodelingPackageImpl#getAnalysisLevel()
		 * @generated
		 */
		EClass ANALYSIS_LEVEL = eINSTANCE.getAnalysisLevel();

		/**
		 * The meta object literal for the '{@link eastadl21.east_adl.structure.systemmodeling.impl.DesignLevelImpl <em>Design Level</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see eastadl21.east_adl.structure.systemmodeling.impl.DesignLevelImpl
		 * @see eastadl21.east_adl.structure.systemmodeling.impl.SystemmodelingPackageImpl#getDesignLevel()
		 * @generated
		 */
		EClass DESIGN_LEVEL = eINSTANCE.getDesignLevel();

		/**
		 * The meta object literal for the '{@link eastadl21.east_adl.structure.systemmodeling.impl.ImplementationLevelImpl <em>Implementation Level</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see eastadl21.east_adl.structure.systemmodeling.impl.ImplementationLevelImpl
		 * @see eastadl21.east_adl.structure.systemmodeling.impl.SystemmodelingPackageImpl#getImplementationLevel()
		 * @generated
		 */
		EClass IMPLEMENTATION_LEVEL = eINSTANCE.getImplementationLevel();

	}

} //SystemmodelingPackage
